<template>
  <div class="fr-container fr-p-5w">
    <TheHeader title="Bénéficiaires" />
    <BeneficiarySearchbar class="fr-mt-3w" />
    <div class="fr-grid-row fr-grid-row--gutters fr-mt-3w">
      <div class="fr-col-12">
        <main class="main-container fr-py-3w">
          <AtomAlert
            v-if="error"
            class="fr-mx-5v"
            :alert-type="AlertType.Error"
            message="La liste des bénéficiaires n'a pas pu être chargée."
          />
          <template v-else>
            <BeneficiaryFilters
              class="fr-px-5v"
              @filter="onFilter"
            />
            <hr />
            <p class="fr-mb-2w fr-mx-5v fr-hint-text">
              {{ beneficiariesCount }} bénéficiaire(s)
            </p>
            <AtomLoader
              v-show="pending"
              class="fr-mx-auto"
            />
            <div
              v-show="!pending"
              ref="tableContainer"
              class="table-container"
              tabindex="0"
            >
              <div
                class="fr-table fr-table--bordered fr-table--no-caption fr-mb-0 fr-pt-0"
              >
                <table>
                  <caption>
                    Liste des bénéficiaires
                  </caption>
                  <thead>
                    <tr>
                      <th scope="col">
                        Nom
                        <AtomSortButton @sort="onSort($event, 'usual_name')" />
                      </th>
                      <th scope="col">
                        Prénom
                        <AtomSortButton @sort="onSort($event, 'firstname')" />
                      </th>
                      <th scope="col">Âge</th>
                      <th scope="col">Date de naissance</th>
                      <th scope="col">Adresse postale</th>
                      <th scope="col">Ville</th>
                      <th scope="col">Téléphone</th>
                      <th scope="col">Types d'accompagnement</th>
                      <th scope="col">Référents</th>
                      <th scope="col">Statut du dossier</th>
                      <th scope="col">N° dossier</th>
                    </tr>
                  </thead>
                  <tbody>
                    <BeneficiaryRow
                      v-for="beneficiary in beneficiaries"
                      :key="beneficiary.id"
                      :beneficiary="beneficiary"
                    />
                  </tbody>
                </table>
              </div>
            </div>
            <AtomPagination
              v-show="!pending"
              class="fr-mt-4w fr-px-5v"
              :page="page"
              :total="beneficiariesCount"
              @change-page="updatePagination($event)"
            />

            <HistoryItem
              class="fr-mt-4w fr-px-5v"
              collection="beneficiary"
              :route-with-params="Routes.Beneficiary"
            />
          </template>
        </main>
      </div>
    </div>
  </div>
</template>

<script setup>
  import { useFiltersStore } from '~/store/filters'
  import { REQUEST_LIMIT_DEFAULT } from '~/utils/constants'
  import { AlertType } from '~/utils/constants/alert'
  import { errorResponseMessage } from '~/utils/errorResponse'
  import { getRandomId } from '~/utils/random'
  import { Routes } from '~/utils/routing/routes'

  const filtersStore = useFiltersStore()
  const { $getItems } = useNuxtApp()

  const {
    data: beneficiaries,
    pending: beneficiariesPending,
    error: beneficiariesError,
    refresh: beneficiariesRefresh
  } = useLazyAsyncData(getRandomId('beneficiaries'), loadBeneficiaries, {
    server: false
  })

  const {
    data: beneficiariesCount,
    pending: beneficiariesCountPending,
    error: beneficiariesCountError,
    refresh: beneficiariesCountRefresh
  } = useLazyAsyncData(
    getRandomId('beneficiariesCount'),
    loadBeneficiariesCount,
    {
      server: false,
      default: () => 0
    }
  )

  const filters = ref(filtersStore.beneficiary.directusQuery)
  const sorts = ref([])
  const page = ref(1)
  const limit = ref(REQUEST_LIMIT_DEFAULT)
  const tableContainer = ref(null)

  const pending = computed(
    () => beneficiariesPending.value || beneficiariesCountPending.value
  )

  const error = computed(
    () => beneficiariesError.value || beneficiariesCountError.value
  )

  watch(pending, _pending => {
    // Scroll the table container to top after reloading
    if (tableContainer.value && !_pending) {
      nextTick(() => (tableContainer.value.scrollTop = 0))
    }
  })

  function updatePagination({ pageNumber, limitValue }) {
    page.value = pageNumber
    limit.value = Number(limitValue)
    beneficiariesRefresh()
  }

  async function loadBeneficiaries() {
    const query = {
      fields: [
        'id',
        'usual_name',
        'birth_name',
        'firstname',
        'birthdate',
        'street_number',
        'street',
        'city',
        'phone_1',
        'follow_ups.follow_up_types.follow_up_types_id.name',
        'follow_ups.follow_up_types.follow_up_types_id.id',
        'help_requests.follow_up_type.id',
        'help_requests.follow_up_type.name',
        'referents.referent.first_name',
        'referents.referent.last_name',
        'status'
      ],
      limit: limit.value,
      page: page.value,
      sort: sorts.value.length ? sorts.value : undefined
    }
    if (filters.value) query.filter = filters.value

    const res = await $getItems('beneficiary', query)

    if (res.status === 200) return res.data.data
    throw new Error(errorResponseMessage(res))
  }

  // NOTE: It is not using `filter_count` meta in the query loading the items due to a Directus bug - See https://github.com/directus/directus/discussions/16992
  async function loadBeneficiariesCount() {
    const query = { aggregate: { countDistinct: 'id' } }
    if (filters.value) query.filter = filters.value

    const res = await $getItems('beneficiary', query)

    if (res.status === 200) return parseInt(res.data.data[0].countDistinct.id)
    throw new Error(errorResponseMessage(res))
  }

  function onFilter(_filters) {
    filters.value = _filters
    beneficiariesRefresh()
    beneficiariesCountRefresh()
  }

  function onSort(sortDir, field) {
    sorts.value = sorts.value.filter(s => s.field !== field)
    sorts.value.unshift({ field, sort: sortDir })
    beneficiariesRefresh()
  }
</script>

<style lang="scss" scoped>
  .table-container {
    // 21.5rem seems to come up out of the box. It corresponds to the total height of elements existing above the table
    max-height: calc(100vh - 21.5rem);
  }
</style>
